package it.integry.integrywmsnative.gest.ordini_uscita_elenco.filters;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.databinding.DataBindingUtil;
import androidx.lifecycle.MutableLiveData;

import com.annimon.stream.ComparatorCompat;
import com.annimon.stream.Stream;
import com.ravikoradiya.liveadapter.LiveAdapter;

import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.Objects;

import it.integry.integrywmsnative.BR;
import it.integry.integrywmsnative.R;
import it.integry.integrywmsnative.core.di.BindableBoolean;
import it.integry.integrywmsnative.core.expansion.RunnableArgs;
import it.integry.integrywmsnative.core.utility.UtilityBoolean;
import it.integry.integrywmsnative.databinding.LayoutFilterVettoreBinding;
import it.integry.integrywmsnative.ui.filter_chips.FilterLayoutView;

public class FilterVettoreLayoutView extends FilterLayoutView {

    protected LayoutFilterVettoreBinding mBindings;

    private List<String> allVettori;
    private List<String> availableVettori;
    private List<String> preSelectedVettori = new ArrayList<>();
    private List<String> hiddenSelectedVettori = new ArrayList<>();
    private final MutableLiveData<List<ListModel>> listModel = new MutableLiveData<>();

    private RunnableArgs<List<String>> onFilterApplied;

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        mBindings = DataBindingUtil.inflate(inflater, R.layout.layout_filter_vettore, container, false);
        this.mBindings.setView(this);

        refreshList();

        this.setSearchView(this.mBindings.searchView, newFilter -> {
            hiddenSelectedVettori = Stream.of(allVettori)
                    .filter(x -> !x.toUpperCase(Locale.ROOT).contains(newFilter.toUpperCase(Locale.ROOT)))
                    .toList();

            refreshList();
        });



        new LiveAdapter(listModel, getViewLifecycleOwner(), BR.item)
                .map(ListModel.class, R.layout.layout_filter_vettore__list_item)
                .into(this.mBindings.recyclerview);

        return mBindings.getRoot();
    }

    private void refreshList() {
        ComparatorCompat<ListModel> c =
                ComparatorCompat
                        .chain(new ComparatorCompat<ListModel>((x, y) -> UtilityBoolean.toInt(x.getSelected().get()) - UtilityBoolean.toInt(y.getSelected().get())))
                        .thenComparing(new ComparatorCompat<>((x, y) -> UtilityBoolean.toInt(x.getEnabled().get()) - UtilityBoolean.toInt(y.getEnabled().get())))
                        .thenComparing(new ComparatorCompat<>((x, y) -> y.getOriginalModel().compareTo(x.getOriginalModel())))
                        .reversed();

        listModel.setValue(Stream.of(getAllVettori())
                .filter(x -> !hiddenSelectedVettori.contains(x))
                .map(x -> {
                    var selectedBoolean = new BindableBoolean(preSelectedVettori.contains(x));
                    selectedBoolean.addOnPropertyChangedCallback(() -> {
                        if (selectedBoolean.get()) preSelectedVettori.add(x);
                        else preSelectedVettori.remove(x);
                    });

                    return new ListModel()
                        .setSelected(selectedBoolean)
                        .setEnabled(new BindableBoolean(availableVettori.contains(x)))
                        .setOriginalModel(x);
                })
                .sorted(c)
                .toList());
    }


    public void onConfirm() {
        if (onFilterApplied == null) return;

        this.onFilterApplied.run(Stream.of(Objects.requireNonNull(listModel.getValue()))
                .filter(x -> x.selected.get())
                .map(x -> x.originalModel)
                .toList());

        dismiss();
    }

    public List<String> getAllVettori() {
        return allVettori;
    }

    public FilterVettoreLayoutView setAllVettori(List<String> allVettori) {
        this.allVettori = allVettori;
        return this;
    }

    public List<String> getAvailableVettori() {
        return availableVettori;
    }

    public FilterVettoreLayoutView setAvailableVettori(List<String> availableVettori) {
        this.availableVettori = availableVettori;
        return this;
    }

    public List<String> getPreSelectedVettori() {
        return preSelectedVettori;
    }

    public FilterVettoreLayoutView setPreSelectedVettori(List<String> preSelectedVettori) {
        this.preSelectedVettori = preSelectedVettori;
        return this;
    }

    public RunnableArgs<List<String>> getOnFilterApplied() {
        return onFilterApplied;
    }

    public FilterVettoreLayoutView setOnFilterApplied(RunnableArgs<List<String>> onFilterApplied) {
        this.onFilterApplied = onFilterApplied;
        return this;
    }

    public static class ListModel {
        private BindableBoolean selected = new BindableBoolean();
        private BindableBoolean enabled = new BindableBoolean();
        private String originalModel;

        public BindableBoolean getSelected() {
            return selected;
        }

        public ListModel setSelected(BindableBoolean selected) {
            this.selected = selected;
            return this;
        }

        public BindableBoolean getEnabled() {
            return enabled;
        }

        public ListModel setEnabled(BindableBoolean enabled) {
            this.enabled = enabled;
            return this;
        }

        public String getOriginalModel() {
            return originalModel;
        }

        public ListModel setOriginalModel(String originalModel) {
            this.originalModel = originalModel;
            return this;
        }
    }

}
